searchNodes=[{"ref":"Mix.Tasks.Serum.html","title":"Mix.Tasks.Serum","type":"task","doc":"Prints a list of available Serum tasks. mix serum This task does not take any command line argument."},{"ref":"Mix.Tasks.Serum.Build.html","title":"Mix.Tasks.Serum.Build","type":"task","doc":"Builds the Serum project at the specified directory. mix serum.build [(-o|--output) PATH] The website will be built into PATH if -o(--output) PATH option is given, otherwise /path/to/project/site directory. If the output directory exists and is not empty, all files and directories under that directory will be deleted before the build process begins. However, any files or directories which names start with a dot (.) are preserved, as they may contain important information such as version control-related data. Options -o(--output) (string): Specifies the output directory. Defaults to /path/to/project/site."},{"ref":"Mix.Tasks.Serum.Gen.Page.html","title":"Mix.Tasks.Serum.Gen.Page","type":"task","doc":"Adds a new page to the current project. mix serum.gen.page (-t|--title) TITLE (-o|--output) OUTPUT [Options] Required Options -t(--title) (string): Title of the new page. -o(--output) (string): The path where the new page will be saved, relative to pages/ directory. It must end with one of .md, .html, or .html.eex. Other Options -l(--label) (string): Label of the new page. Defaults to the page title. -g(--group) (string): Name of a group the new page belongs to. -r(--order) (integer): The order of the new page in a group. Defaults to 0."},{"ref":"Mix.Tasks.Serum.Gen.Post.html","title":"Mix.Tasks.Serum.Gen.Post","type":"task","doc":"Adds a new blog post to the current project. mix serum.gen.post (-t|--title) TITLE (-o|--output) OUTPUT [Options] Post date will be automatically set to the moment this task is executed. Required Options -t(--title) (string): Title of the new blog post. -o(--output) (string): Name of the generated post file. The actual path to the generated file will be in the form of posts/YYYY-MM-DD-&lt;OUTPUT&gt;.md. Other Options -g(--tag) (string): Tag(s) of the new post. You can provide this option zero or more times to give multiple tags to the post."},{"ref":"Mix.Tasks.Serum.Server.html","title":"Mix.Tasks.Serum.Server","type":"task","doc":"Starts the Serum development server. mix serum.server [(-p|--port) PORT] This task builds the current Serum project at a temporary directory, and starts the development server. The server uses the port 8080 by default. Options -p(--port) (integer): Use a specific port instead of 8080. This is useful when the default port is not available for use."},{"ref":"Serum.html","title":"Serum","type":"module","doc":"Defines Serum OTP application. Serum is a simple static website generator written in Elixir programming language. The goal of this project is to provide the way to create awesome static websites with little effort. This documentation is for developers and advanced users. For the getting started guide and the user manual, please visit the official Serum website. Also, documentations for modules related to the internal operation of Serum are hidden. But such modules are still documented in their source codes."},{"ref":"Serum.html#start/2","title":"Serum.start/2","type":"function","doc":"Starts the :serum application. This starts a supervisor process which manages some children maintaining states or data required for execution of Serum."},{"ref":"Serum.Build.html","title":"Serum.Build","type":"module","doc":"A module for managing the overall project build procedure."},{"ref":"Serum.Build.html#build/1","title":"Serum.Build.build/1","type":"function","doc":"Builds the given Serum project. Build Procedure Tries to load plugins and a theme. Checks if the system timezone is properly set. Timex requires the local timezone information to format the date/time string. If it&#39;s not set or invalid, Timex will fail. Checks if the current user has enough permission on the destination directory and cleans it if it already exists. Loads source files. See Serum.Build.FileLoader. Processes source files and produces intermediate data structures. See Serum.Build.FileProcessor. Generates HTML fragments from the intermediate data. See Serum.Build.FragmentGenerator. Renders full HTML pages from fragments and writes them to files. See Serum.Build.FileEmitter. Copies assets/ and media/ directories if they exist."},{"ref":"Serum.DevServer.html","title":"Serum.DevServer","type":"module","doc":"The Serum development server."},{"ref":"Serum.DevServer.html#run/2","title":"Serum.DevServer.run/2","type":"function","doc":"Starts the Serum development server. This function returns {:ok, pid} on success where pid is a process ID of a supervision tree for the Serum development server."},{"ref":"Serum.DevServer.Prompt.html","title":"Serum.DevServer.Prompt","type":"module","doc":"Provides access to the Serum development server command line interface."},{"ref":"Serum.DevServer.Prompt.html#start/1","title":"Serum.DevServer.Prompt.start/1","type":"function","doc":"Tries to start a Serum development server command line interface. This function first checks if the server is already running. If the server is not running, this function returns {:error, :noproc} immediately. Otherwise, it starts a loop which processes commands from the user. If the user runs the detach command, the loop completes and this function returns {:ok, :detached} tuple. If the user runs the quit command, the Serum development server will be stopped, and then this function will return {:ok, :quitted} tuple. Options allow_detach: Controls if users are allowed to detach the command line interface. Defaults to true."},{"ref":"Serum.DevServer.Prompt.html#t:options/0","title":"Serum.DevServer.Prompt.options/0","type":"type","doc":""},{"ref":"Serum.DevServer.Prompt.html#t:result/0","title":"Serum.DevServer.Prompt.result/0","type":"type","doc":""},{"ref":"Serum.File.html","title":"Serum.File","type":"module","doc":"Defines a struct representing a file to be read or written. Fields src: Source path dest: Destination path in_data: Data read from a file out_data: Data to be written to a file"},{"ref":"Serum.File.html#read/1","title":"Serum.File.read/1","type":"function","doc":"Reads data from a file described by the given Serum.File struct. An error will be returned if src is nil."},{"ref":"Serum.File.html#write/1","title":"Serum.File.write/1","type":"function","doc":"Writes data to a file described by the given Serum.File struct. An error will be returned if dest is nil."},{"ref":"Serum.File.html#t:t/0","title":"Serum.File.t/0","type":"type","doc":""},{"ref":"Serum.Fragment.html","title":"Serum.Fragment","type":"module","doc":"Defines a struct representing a page fragment. Fields file: Source path. This can be nil if created internally. output: Destination path metadata: A map holding extra information about the fragment data: Contents of the page fragment"},{"ref":"Serum.Fragment.html#new/4","title":"Serum.Fragment.new/4","type":"function","doc":"Creates a new Fragment struct."},{"ref":"Serum.Fragment.html#t:t/0","title":"Serum.Fragment.t/0","type":"type","doc":""},{"ref":"Serum.Page.html","title":"Serum.Page","type":"module","doc":"Defines a struct describing a normal page. Fields file: Source path type: Type of source file title: Page title label: Page label group: A group the page belongs to order: Order of the page within its group url: Absolute URL of the page within the website output: Destination path data: Source data"},{"ref":"Serum.Page.html#compact/1","title":"Serum.Page.compact/1","type":"function","doc":""},{"ref":"Serum.Page.html#new/4","title":"Serum.Page.new/4","type":"function","doc":""},{"ref":"Serum.Page.html#to_fragment/2","title":"Serum.Page.to_fragment/2","type":"function","doc":""},{"ref":"Serum.Page.html#t:t/0","title":"Serum.Page.t/0","type":"type","doc":""},{"ref":"Serum.Post.html","title":"Serum.Post","type":"module","doc":"Defines a struct representing a blog post page. Fields file: Source path title: Post title date: Post date (formatted) raw_date: Post date (erlang tuple style) tags: A list of tags url: Absolute URL of the blog post in the website html: Post contents converted into HTML preview: Preview text of the post output: Destination path"},{"ref":"Serum.Post.html#compact/1","title":"Serum.Post.compact/1","type":"function","doc":""},{"ref":"Serum.Post.html#new/4","title":"Serum.Post.new/4","type":"function","doc":""},{"ref":"Serum.Post.html#to_fragment/2","title":"Serum.Post.to_fragment/2","type":"function","doc":""},{"ref":"Serum.Post.html#t:t/0","title":"Serum.Post.t/0","type":"type","doc":""},{"ref":"Serum.PostList.html","title":"Serum.PostList","type":"module","doc":"Defines a struct representing a list of blog posts. Fields tag: Specifies by which tag the posts are filtered. Can be nil current_page: Number of current page max_page: Number of the last page title: Title of the list posts: A list of Post structs url: Absolute URL of this list page in the website prev_url: Absolute URL of the previous list page. Can be nil if this is the first page next_url: Absolute URL of the next list page. Can be nil if this is the last page output: Destination path"},{"ref":"Serum.PostList.html#compact/1","title":"Serum.PostList.compact/1","type":"function","doc":""},{"ref":"Serum.PostList.html#generate/3","title":"Serum.PostList.generate/3","type":"function","doc":""},{"ref":"Serum.PostList.html#to_fragment/2","title":"Serum.PostList.to_fragment/2","type":"function","doc":""},{"ref":"Serum.PostList.html#t:maybe_tag/0","title":"Serum.PostList.maybe_tag/0","type":"type","doc":""},{"ref":"Serum.PostList.html#t:t/0","title":"Serum.PostList.t/0","type":"type","doc":""},{"ref":"Serum.Project.html","title":"Serum.Project","type":"module","doc":"This module defines a struct for storing Serum project metadata."},{"ref":"Serum.Project.html#default_date_format/0","title":"Serum.Project.default_date_format/0","type":"function","doc":""},{"ref":"Serum.Project.html#default_list_title_tag/0","title":"Serum.Project.default_list_title_tag/0","type":"function","doc":""},{"ref":"Serum.Project.html#new/1","title":"Serum.Project.new/1","type":"function","doc":"A helper function for creating a new Project struct."},{"ref":"Serum.Project.html#t:t/0","title":"Serum.Project.t/0","type":"type","doc":""},{"ref":"Serum.Result.html","title":"Serum.Result","type":"module","doc":"This module defines types for positive results or errors returned by functions in this project."},{"ref":"Serum.Result.html#aggregate/2","title":"Serum.Result.aggregate/2","type":"function","doc":"Takes a list of results without value and checks if there is no error. Returns :ok if there is no error. Returns an aggregated error object if there is one or more errors."},{"ref":"Serum.Result.html#aggregate_values/2","title":"Serum.Result.aggregate_values/2","type":"function","doc":"Takes a list of results with values and checks if there is no error. If there is no error, it returns {:ok, list} where list is a list of returned values. Returns an aggregated error object if there is one or more errors."},{"ref":"Serum.Result.html#get_message/2","title":"Serum.Result.get_message/2","type":"function","doc":"Gets a human friendly message from the given result. You can control the indentation level by passing a non-negative integer to the depth parameter."},{"ref":"Serum.Result.html#show/2","title":"Serum.Result.show/2","type":"function","doc":"Prints an error object in a beautiful format."},{"ref":"Serum.Result.html#t:err_details/0","title":"Serum.Result.err_details/0","type":"type","doc":""},{"ref":"Serum.Result.html#t:error/0","title":"Serum.Result.error/0","type":"type","doc":""},{"ref":"Serum.Result.html#t:full_detail/0","title":"Serum.Result.full_detail/0","type":"type","doc":""},{"ref":"Serum.Result.html#t:msg_detail/0","title":"Serum.Result.msg_detail/0","type":"type","doc":""},{"ref":"Serum.Result.html#t:nest_detail/0","title":"Serum.Result.nest_detail/0","type":"type","doc":""},{"ref":"Serum.Result.html#t:t/0","title":"Serum.Result.t/0","type":"type","doc":""},{"ref":"Serum.Result.html#t:t/1","title":"Serum.Result.t/1","type":"type","doc":""},{"ref":"Serum.Tag.html","title":"Serum.Tag","type":"module","doc":"This module defines Tag struct."},{"ref":"Serum.Tag.html#batch_create/2","title":"Serum.Tag.batch_create/2","type":"function","doc":""},{"ref":"Serum.Tag.html#new/2","title":"Serum.Tag.new/2","type":"function","doc":""},{"ref":"Serum.Tag.html#t:t/0","title":"Serum.Tag.t/0","type":"type","doc":""},{"ref":"Serum.Template.html","title":"Serum.Template","type":"module","doc":"Defines a struct which stores a template and its information."},{"ref":"Serum.Template.html#new/3","title":"Serum.Template.new/3","type":"function","doc":""},{"ref":"Serum.Template.html#t:t/0","title":"Serum.Template.t/0","type":"type","doc":""},{"ref":"Serum.Template.html#t:template_type/0","title":"Serum.Template.template_type/0","type":"type","doc":""},{"ref":"Serum.Plugins.LiveReloader.html","title":"Serum.Plugins.LiveReloader","type":"module","doc":"A Serum plugin that injects the live reloader script at the end of HTML files. Once the page is loaded inside your web browser, the injected script tries to connect to the Serum development server via WebSocket. When the page receives &quot;reload&quot; message from the server, it refreshes the current page. If you disable this plugin, you need to manually refresh the page after you made some changes to your source files. Using the Plugin You usually don&#39;t want the script injected into pages when the Serum development server is not running. Let the plugin run only when Mix.env() is dev, and run MIX_ENV=prod mix serum.build when you are about to publish your website. # serum.exs: %{ plugins: [ {Serum.Plugins.LiveReloader, only: :dev} ] }"},{"ref":"Serum.Plugins.LiveReloader.html#description/0","title":"Serum.Plugins.LiveReloader.description/0","type":"function","doc":"Returns the short description of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.description/0."},{"ref":"Serum.Plugins.LiveReloader.html#elixir/0","title":"Serum.Plugins.LiveReloader.elixir/0","type":"function","doc":"Returns the version requirement of Elixir. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.elixir/0."},{"ref":"Serum.Plugins.LiveReloader.html#implements/0","title":"Serum.Plugins.LiveReloader.implements/0","type":"function","doc":"Returns a list of optional callbacks which the plugin implements. For example, if your plugin implements build_started/2 and finalizing/2, you must implement this callback so that it returns [:build_started, :finalizing]. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.implements/0."},{"ref":"Serum.Plugins.LiveReloader.html#name/0","title":"Serum.Plugins.LiveReloader.name/0","type":"function","doc":"Returns the name of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.name/0."},{"ref":"Serum.Plugins.LiveReloader.html#rendered_page/1","title":"Serum.Plugins.LiveReloader.rendered_page/1","type":"function","doc":"Called when Serum has rendered a full page and it&#39;s about to write to an output file. Plugins can alter the raw contents of the page to be written. Callback implementation for Serum.Plugin.rendered_page/1."},{"ref":"Serum.Plugins.LiveReloader.html#serum/0","title":"Serum.Plugins.LiveReloader.serum/0","type":"function","doc":"Returns the version requirement of Serum. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.serum/0."},{"ref":"Serum.Plugins.LiveReloader.html#version/0","title":"Serum.Plugins.LiveReloader.version/0","type":"function","doc":"Returns the version of the plugin. The returned version string must follow the semantic versioning scheme. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.version/0."},{"ref":"Serum.Plugins.SitemapGenerator.html","title":"Serum.Plugins.SitemapGenerator","type":"module","doc":"A Serum plugin that create a sitemap so that the search engine can index posts. Using the Plugin # serum.exs: %{ server_root: &quot;https://example.io&quot;, plugins: [ {Serum.Plugins.SitemapGenerator, only: :prod} ] }"},{"ref":"Serum.Plugins.SitemapGenerator.html#build_succeeded/2","title":"Serum.Plugins.SitemapGenerator.build_succeeded/2","type":"function","doc":"Called if the whole build process has finished successfully. Callback implementation for Serum.Plugin.build_succeeded/2."},{"ref":"Serum.Plugins.SitemapGenerator.html#description/0","title":"Serum.Plugins.SitemapGenerator.description/0","type":"function","doc":"Returns the short description of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.description/0."},{"ref":"Serum.Plugins.SitemapGenerator.html#elixir/0","title":"Serum.Plugins.SitemapGenerator.elixir/0","type":"function","doc":"Returns the version requirement of Elixir. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.elixir/0."},{"ref":"Serum.Plugins.SitemapGenerator.html#implements/0","title":"Serum.Plugins.SitemapGenerator.implements/0","type":"function","doc":"Returns a list of optional callbacks which the plugin implements. For example, if your plugin implements build_started/2 and finalizing/2, you must implement this callback so that it returns [:build_started, :finalizing]. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.implements/0."},{"ref":"Serum.Plugins.SitemapGenerator.html#name/0","title":"Serum.Plugins.SitemapGenerator.name/0","type":"function","doc":"Returns the name of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.name/0."},{"ref":"Serum.Plugins.SitemapGenerator.html#serum/0","title":"Serum.Plugins.SitemapGenerator.serum/0","type":"function","doc":"Returns the version requirement of Serum. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.serum/0."},{"ref":"Serum.Plugins.SitemapGenerator.html#version/0","title":"Serum.Plugins.SitemapGenerator.version/0","type":"function","doc":"Returns the version of the plugin. The returned version string must follow the semantic versioning scheme. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.version/0."},{"ref":"Serum.Plugins.TableOfContents.html","title":"Serum.Plugins.TableOfContents","type":"module","doc":"A Serum plugin that inserts a table of contents. Using the Plugin First, add this plugin to your serum.exs: %{ plugins: [ Serum.Plugins.TableOfContents ] } This plugin works with both pages(.md, .html, and .html.eex) and blog posts(.md). Insert the &lt;serum-toc&gt; tag at the position you want to display a table of contents at. &lt;serum-toc start=&quot;2&quot; end=&quot;4&quot;&gt;&lt;/serum-toc&gt; The start and end attributes define a range of heading level this plugin recognizes. In the case of the above example, &lt;h1&gt;, &lt;h5&gt;, and &lt;h6&gt; tags are ignored when generating a table of contents. After this plugin has run, each &lt;serum-toc&gt; tag is replaced with an unordered list: &lt;ul id=&quot;toc&quot; class=&quot;serum-toc&quot;&gt; &lt;li class=&quot;indent-0&quot;&gt; &lt;a href=&quot;#s_1&quot;&gt; &lt;span class=&quot;number&quot;&gt;1&lt;/span&gt; Section 1 &lt;/a&gt; &lt;/li&gt; &lt;!-- More list items here... --&gt; &lt;/ul&gt; This plugin produces a &quot;flat&quot; unordered list. However, each list item tag has an indent-x class, where x is an indentation level (from 0 to 5) of the current item in the list. You can utilize this when working on stylesheets. The id attribute of each target heading tag is used when hyperlinks are generated. If the element does not have an id, the plugin will set one appropriately. Notes You may use &lt;serum-toc&gt; tag more than once in a single page. However, all occurrences of this tag will be replaced with a table of contents generated using the attributes of the first one. That is, for example, all three tags in the code below expand to the same table of contents, showing a 2-level deep list. &lt;serum-toc start=&quot;2&quot; end=&quot;3&quot;&gt;&lt;/serum-toc&gt; ... &lt;serum-toc&gt;&lt;/serum-toc&gt; ... &lt;serum-toc&gt;&lt;/serum-toc&gt; It&#39;s recommended that you wrap a &lt;serum-toc&gt; tag with a &lt;div&gt; tag when using in a markdown file, to ensure a well-formed structure of HTML output. &lt;div&gt;&lt;serum-toc ...&gt;&lt;/serum-toc&gt;&lt;/div&gt; And finally, make sure you close every &lt;serum-toc&gt; tag properly with &lt;/serum-toc&gt;."},{"ref":"Serum.Plugins.TableOfContents.html#description/0","title":"Serum.Plugins.TableOfContents.description/0","type":"function","doc":"Returns the short description of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.description/0."},{"ref":"Serum.Plugins.TableOfContents.html#elixir/0","title":"Serum.Plugins.TableOfContents.elixir/0","type":"function","doc":"Returns the version requirement of Elixir. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.elixir/0."},{"ref":"Serum.Plugins.TableOfContents.html#implements/0","title":"Serum.Plugins.TableOfContents.implements/0","type":"function","doc":"Returns a list of optional callbacks which the plugin implements. For example, if your plugin implements build_started/2 and finalizing/2, you must implement this callback so that it returns [:build_started, :finalizing]. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.implements/0."},{"ref":"Serum.Plugins.TableOfContents.html#name/0","title":"Serum.Plugins.TableOfContents.name/0","type":"function","doc":"Returns the name of the plugin. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.name/0."},{"ref":"Serum.Plugins.TableOfContents.html#rendering_fragment/2","title":"Serum.Plugins.TableOfContents.rendering_fragment/2","type":"function","doc":"Called while each fragment is being constructed. Plugins can alter the HTML tree of its contents (which is generated by Floki). It is recommended to implement this callback if you want to modify the HTML document without worrying about breaking it. Callback implementation for Serum.Plugin.rendering_fragment/2."},{"ref":"Serum.Plugins.TableOfContents.html#serum/0","title":"Serum.Plugins.TableOfContents.serum/0","type":"function","doc":"Returns the version requirement of Serum. Refer to this document for the string format. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.serum/0."},{"ref":"Serum.Plugins.TableOfContents.html#version/0","title":"Serum.Plugins.TableOfContents.version/0","type":"function","doc":"Returns the version of the plugin. The returned version string must follow the semantic versioning scheme. You must implement this callback, or the plugin may fail. Callback implementation for Serum.Plugin.version/0."},{"ref":"Serum.HtmlTreeHelper.html","title":"Serum.HtmlTreeHelper","type":"module","doc":"Provides useful functions for working with HTML trees."},{"ref":"Serum.HtmlTreeHelper.html#traverse/2","title":"Serum.HtmlTreeHelper.traverse/2","type":"function","doc":"Performs a post-order traversal of the given HTML tree."},{"ref":"Serum.HtmlTreeHelper.html#traverse/3","title":"Serum.HtmlTreeHelper.traverse/3","type":"function","doc":"Performs a post-order traversal of the given HTML tree with an accumulator."},{"ref":"Serum.HtmlTreeHelper.html#t:acc_tree_fun/0","title":"Serum.HtmlTreeHelper.acc_tree_fun/0","type":"type","doc":""},{"ref":"Serum.HtmlTreeHelper.html#t:attribute/0","title":"Serum.HtmlTreeHelper.attribute/0","type":"type","doc":""},{"ref":"Serum.HtmlTreeHelper.html#t:tag/0","title":"Serum.HtmlTreeHelper.tag/0","type":"type","doc":""},{"ref":"Serum.HtmlTreeHelper.html#t:tree/0","title":"Serum.HtmlTreeHelper.tree/0","type":"type","doc":""},{"ref":"Serum.HtmlTreeHelper.html#t:tree_fun/0","title":"Serum.HtmlTreeHelper.tree_fun/0","type":"type","doc":""},{"ref":"Serum.Plugin.html","title":"Serum.Plugin","type":"behaviour","doc":"A behaviour that all Serum plugin module must implement. This module allows experienced Serum users and developers to make their own Serum plugins which can extend the functionality of Serum. A Serum plugin can... Alter contents of input or output files, Execute arbitrary codes during some stages of site building, And optionally provide extra Mix tasks that extends Serum. For Plugin Developers In order for a Serum plugin to work, you must implement at least these four callbacks: name/0 version/0 elixir/0 serum/0 description/0 implements/0 Also there are a number of other callbacks you can optionally implement. Read the rest of the documentation for this module to see which callbacks you can implement and what each callback should do. For Plugin Users To enable Serum plugins, add a plugins key to your serum.exs(if it does not exist), and put names of Serum plugin modules there. %{ plugins: [ Awesome.Serum.Plugin, Great.Serum.Plugin ] } You can also restrict some plugins to run only in specific Mix environments. For example, if plugins are configured like the code below, only Awesome.Serum.Plugin plugin will be loaded when MIX_ENV is set to prod. %{ plugins: [ Awesome.Serum.Plugin, {Great.Serum.Plugin, only: :dev}, {Another.Serum.Plugin, only: [:dev, :test]} ] } The order of plugins is important, as Serum will call plugins one by one, from the first item to the last one. Therefore these two configurations below may produce different results. Configuration 1: %{ plugins: [ Awesome.Serum.Plugin, Another.Serum.Plugin ] } Configuration 2: %{ plugins: [ Another.Serum.Plugin, Awesome.Serum.Plugin ] }"},{"ref":"Serum.Plugin.html#c:build_failed/3","title":"Serum.Plugin.build_failed/3","type":"callback","doc":"Called if the build process has failed for some reason."},{"ref":"Serum.Plugin.html#c:build_started/2","title":"Serum.Plugin.build_started/2","type":"callback","doc":"Called right after the build process has started. Some necessary OTP applications or processes should be started here."},{"ref":"Serum.Plugin.html#c:build_succeeded/2","title":"Serum.Plugin.build_succeeded/2","type":"callback","doc":"Called if the whole build process has finished successfully."},{"ref":"Serum.Plugin.html#child_spec/1","title":"Serum.Plugin.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Serum.Plugin.html#c:description/0","title":"Serum.Plugin.description/0","type":"callback","doc":"Returns the short description of the plugin. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:elixir/0","title":"Serum.Plugin.elixir/0","type":"callback","doc":"Returns the version requirement of Elixir. Refer to this document for the string format. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:finalizing/2","title":"Serum.Plugin.finalizing/2","type":"callback","doc":"Called right before Serum exits, whether the build has succeeded or not. This is the place where you should clean up any temporary resources created in build_started/2 callback."},{"ref":"Serum.Plugin.html#c:implements/0","title":"Serum.Plugin.implements/0","type":"callback","doc":"Returns a list of optional callbacks which the plugin implements. For example, if your plugin implements build_started/2 and finalizing/2, you must implement this callback so that it returns [:build_started, :finalizing]. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:name/0","title":"Serum.Plugin.name/0","type":"callback","doc":"Returns the name of the plugin. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:processed_list/1","title":"Serum.Plugin.processed_list/1","type":"callback","doc":"Called after Serum has processed each input file and produced the resulting struct. Plugins can alter the processed contents and metadata here."},{"ref":"Serum.Plugin.html#c:processed_page/1","title":"Serum.Plugin.processed_page/1","type":"callback","doc":"Called after Serum has processed each input file and produced the resulting struct. Plugins can alter the processed contents and metadata here."},{"ref":"Serum.Plugin.html#c:processed_pages/1","title":"Serum.Plugin.processed_pages/1","type":"callback","doc":"Called after Serum has successfully processed all pages."},{"ref":"Serum.Plugin.html#c:processed_post/1","title":"Serum.Plugin.processed_post/1","type":"callback","doc":"Called after Serum has processed each input file and produced the resulting struct. Plugins can alter the processed contents and metadata here."},{"ref":"Serum.Plugin.html#c:processed_posts/1","title":"Serum.Plugin.processed_posts/1","type":"callback","doc":"Called after Serum has successfully processed all blog posts."},{"ref":"Serum.Plugin.html#c:processed_template/1","title":"Serum.Plugin.processed_template/1","type":"callback","doc":"Called after Serum has processed each input file and produced the resulting struct. Plugins can alter the AST and its metadata here."},{"ref":"Serum.Plugin.html#c:processing_page/1","title":"Serum.Plugin.processing_page/1","type":"callback","doc":"Called before Serum processes each input file. Plugins can alter the raw contents of input files here."},{"ref":"Serum.Plugin.html#c:processing_post/1","title":"Serum.Plugin.processing_post/1","type":"callback","doc":"Called before Serum processes each input file. Plugins can alter the raw contents of input files here."},{"ref":"Serum.Plugin.html#c:processing_template/1","title":"Serum.Plugin.processing_template/1","type":"callback","doc":"Called before Serum processes each input file. Plugins can alter the raw contents of input files here."},{"ref":"Serum.Plugin.html#c:reading_pages/1","title":"Serum.Plugin.reading_pages/1","type":"callback","doc":"Called before reading input files. Plugins can manipulate the list of files to be read and pass it to the next plugin."},{"ref":"Serum.Plugin.html#c:reading_posts/1","title":"Serum.Plugin.reading_posts/1","type":"callback","doc":"Called before reading input files. Plugins can manipulate the list of files to be read and pass it to the next plugin."},{"ref":"Serum.Plugin.html#c:reading_templates/1","title":"Serum.Plugin.reading_templates/1","type":"callback","doc":"Called before reading input files. Plugins can manipulate the list of files to be read and pass it to the next plugin."},{"ref":"Serum.Plugin.html#c:rendered_fragment/1","title":"Serum.Plugin.rendered_fragment/1","type":"callback","doc":"Called after producing a HTML fragment for each page. Plugins can modify the contents and metadata of each fragment here."},{"ref":"Serum.Plugin.html#c:rendered_page/1","title":"Serum.Plugin.rendered_page/1","type":"callback","doc":"Called when Serum has rendered a full page and it&#39;s about to write to an output file. Plugins can alter the raw contents of the page to be written."},{"ref":"Serum.Plugin.html#c:rendering_fragment/2","title":"Serum.Plugin.rendering_fragment/2","type":"callback","doc":"Called while each fragment is being constructed. Plugins can alter the HTML tree of its contents (which is generated by Floki). It is recommended to implement this callback if you want to modify the HTML document without worrying about breaking it."},{"ref":"Serum.Plugin.html#c:serum/0","title":"Serum.Plugin.serum/0","type":"callback","doc":"Returns the version requirement of Serum. Refer to this document for the string format. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:version/0","title":"Serum.Plugin.version/0","type":"callback","doc":"Returns the version of the plugin. The returned version string must follow the semantic versioning scheme. You must implement this callback, or the plugin may fail."},{"ref":"Serum.Plugin.html#c:wrote_file/1","title":"Serum.Plugin.wrote_file/1","type":"callback","doc":"Called after writing each output to a file."},{"ref":"Serum.Plugin.html#t:plugin_spec/0","title":"Serum.Plugin.plugin_spec/0","type":"type","doc":""},{"ref":"Serum.Plugin.html#t:t/0","title":"Serum.Plugin.t/0","type":"type","doc":""},{"ref":"Serum.Theme.html","title":"Serum.Theme","type":"behaviour","doc":"A behaviour that all Serum theme module must implement. A Serum theme is a set of predefined templates and assets which are used while Serum is building a project. More specifically, a Serum theme is a Mix project which has the following contents: Modules that implement this behaviour, And theme files such as templates, includes, and other assets. These files are usually stored in the priv/ directory. Your theme package must have at least one module that implements this behaviour, as Serum will call callbacks of this behaviour to ensure that your modules provide appropriate theme resources when needed. Using Serum Themes To use a Serum theme, you first need to add the theme package to your dependencies list. # mix.exs defp deps do [ {:serum, &quot;~&gt; 1.0&quot;}, # ... # If the theme is available on Hex.pm: {:serum_theme_sample, &quot;~&gt; 1.0&quot;} # If the theme is available on somewhere else: {:serum_theme_sample, git: &quot;https://github.com/...&quot;} ] end Fetch and build the theme package using mix. $ mix do deps.get, deps.compile To configure your Serum project to use a theme, you need to put a :theme key in your serum.exs. # serum.exs: %{ theme: Serum.Themes.Sample, # ... } Read the documentation provided by the theme author, to see the list of files the theme consists of. Files provided by the theme are always overridden by corresponding files in your project directory. So it is safe to remove files from your project if the theme has ones. Finally, try building your project to see if the theme is applied correctly. $ mix serum.server # Or, $ MIX_ENV=prod mix serum.build"},{"ref":"Serum.Theme.html#c:author/0","title":"Serum.Theme.author/0","type":"callback","doc":"Returns information about the theme author."},{"ref":"Serum.Theme.html#child_spec/1","title":"Serum.Theme.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Serum.Theme.html#c:description/0","title":"Serum.Theme.description/0","type":"callback","doc":"Returns a short descriptive text about the theme."},{"ref":"Serum.Theme.html#c:get_assets/0","title":"Serum.Theme.get_assets/0","type":"callback","doc":"Returns a path to the assets directory. All files in the directory pointed by the returned value will be copied to the destination assets directory using File.cp_r/2. This callback may return false to indicate that no asset will be copied."},{"ref":"Serum.Theme.html#c:get_includes/0","title":"Serum.Theme.get_includes/0","type":"callback","doc":"Returns a list of paths to include files. All paths in the list must end with &quot;.html.eex&quot;. Anything that does not end with &quot;.html.eex&quot; will be ignored. Example Return Value [ &quot;/path/to/theme/priv/includes/nav.html.eex&quot;, &quot;/path/to/theme/priv/includes/sidebar.html.eex&quot;, &quot;/path/to/theme/priv/includes/footer.html.eex&quot; ]"},{"ref":"Serum.Theme.html#c:get_templates/0","title":"Serum.Theme.get_templates/0","type":"callback","doc":"Returns a list of paths to template files. All paths in the list must end with &quot;.html.eex&quot;. Anything that does not end with &quot;.html.eex&quot; will be ignored. Example Return Value [ &quot;/path/to/theme/priv/templates/base.html.eex&quot;, &quot;/path/to/theme/priv/templates/list.html.eex&quot;, &quot;/path/to/theme/priv/templates/post.html.eex&quot; ]"},{"ref":"Serum.Theme.html#c:legal/0","title":"Serum.Theme.legal/0","type":"callback","doc":"Returns the legal information about the theme, such as license."},{"ref":"Serum.Theme.html#c:name/0","title":"Serum.Theme.name/0","type":"callback","doc":"Returns the theme name."},{"ref":"Serum.Theme.html#c:serum/0","title":"Serum.Theme.serum/0","type":"callback","doc":"Returns the required version of Serum. Read the &quot;Requirements&quot; section in the documentation for Version module for more information about version requirement format."},{"ref":"Serum.Theme.html#c:version/0","title":"Serum.Theme.version/0","type":"callback","doc":"Returns the theme version. The returned value must follow the semantic versioning scheme."},{"ref":"Serum.Theme.html#t:t/0","title":"Serum.Theme.t/0","type":"type","doc":""}]